VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Door"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
' Doors are a "4th" layer to the map. While "closed", the door
' occupies the TopLayer() of the Map. When "opened", the image is
' swapped. So when you plop down a door, it saves the TopLayer()
' picture here. When you "open" it during play, it swaps it back.
Private myIndex As Integer
'   0-7 - Key bits; all 0's not locked. All 1's, no key will work.
Private myKey As Byte
' Refs the TileSet for the EncounterMap. Picture of Door Closed.
' Make sure door picture is correctly "blocked."
Private myDoorImage As Byte
'   0-3   - 0-105% (by 7) chance to find hidden. While
'           hidden, shows hidden tile picture above. 0%
'           impossible to find, 105% is not hidden.
'   4-7   - 0-105% (by 7) chance to unlock. If 0%, no
'           chance to unlock with thieve 's tools.
'           105% not locked.
Private myChance As Byte

' If this door represents an exit point, here is the new map name
' it leads to. Can be blank or the same as current map.
Private myMapName As String

' (myX, myY) is the map coordinate of this door
Private myX As Integer
Private myY As Integer
' Triggers attached to this Door
Private myTriggers As New Collection

Public Property Get DoorLocked() As Integer

End Property

Public Property Let DoorLocked(LockIt As Integer)

End Property

Public Property Get Key() As Byte
    Key = myKey
End Property

Public Property Let Key(NewKey As Byte)
    myKey = NewKey
End Property

Public Property Get DoorImage() As Byte
    DoorImage = myDoorImage
End Property

Public Property Let DoorImage(NewDoorImage As Byte)
    myDoorImage = NewDoorImage
End Property

Public Property Get Chance() As Byte
    Chance = myChance
End Property

Public Property Let Chance(NewChance As Byte)
    myChance = NewChance
End Property

Public Property Get X() As Integer
    X = myX
End Property

Public Property Let X(NewX As Integer)
    myX = NewX
End Property

Public Property Get Y() As Integer
    Y = myY
End Property

Public Property Let Y(NewY As Integer)
    myY = Y
End Property

Public Property Get Index() As Integer
    Index = myIndex
End Property

Public Property Let Index(NewIndex As Integer)
    myIndex = NewIndex
End Property

Public Property Get Triggers() As Collection
    Set Triggers = myTriggers
End Property

Public Sub Copy(FromDoor As Door)
    myKey = FromDoor.Key
    myDoorImage = FromDoor.DoorImage
    myChance = FromDoor.Chance
End Sub

Public Sub SaveToFile(ToFile As Integer)
    Put ToFile, , myIndex
    Put ToFile, , myKey
    Put ToFile, , myDoorImage
    Put ToFile, , myChance
End Sub

Public Sub ReadFromFile(FromFile As Integer)
    Get FromFile, , myIndex
    Get FromFile, , myKey
    Get FromFile, , myDoorImage
    Get FromFile, , myChance
End Sub

