VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Kingdom"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Name of the Kingdom
Private myName As String
' Index of Kingdom
Private myIndex As Integer
' Coordinates of Kingdom on World Map
Private myLeft As Integer
Private myTop As Integer
Private myWidth As Integer
Private myHeight As Integer
' NameSet index
Private myNameSet As Integer
' List of PictureFiles for CreatureWithTurns
Private myPictureFiles As New Collection
' Points to the Creature used as a template
Private myTemplate As Creature
' List of Skills for Template
Private mySkills As Collection

Public Property Get Name() As String
    Name = myName
End Property

Public Property Let Name(NewValue As String)
    myName = NewValue
End Property

Public Property Get Index() As Integer
    Index = myIndex
End Property

Public Property Let Index(NewValue As Integer)
    myIndex = NewValue
End Property

Public Property Get NameSet() As Integer
    NameSet = myNameSet
End Property

Public Property Let NameSet(NewValue As Integer)
    myNameSet = NewValue
End Property

Public Property Get Template() As Creature
    Set Template = myTemplate
End Property

Public Property Set Template(CreatureX As Creature)
    Dim TriggerX As Trigger, c As Integer
    Set myTemplate = CreatureX
    ' Set up skills list
    Set mySkills = New Collection
    For Each TriggerX In CreatureX.Triggers
        If TriggerX.IsSkill = True Then
            For c = 1 To mySkills.Count
                If UCase(mySkills(c).Name) > UCase(TriggerX.Name) Then
                    mySkills.Add Item:=TriggerX, Key:="T" & TriggerX.Index, Before:=c
                    Exit For
                End If
            Next c
            If c > mySkills.Count Then
                mySkills.Add Item:=TriggerX, Key:="T" & TriggerX.Index
            End If
        End If
    Next TriggerX
End Property

Public Function AddPictureFile() As Factoid
    ' Adds an PictureFile and returns a reference to that PictureFile
    Dim c As Integer
    Dim PictureFileX As Factoid
    ' Find new available unused index idenifier
    c = 1
    For Each PictureFileX In myPictureFiles
        If PictureFileX.Index >= c Then
            c = PictureFileX.Index + 1
        End If
    Next PictureFileX
    ' Set the index and add the door. Return the new door's index.
    Set PictureFileX = New Factoid
    PictureFileX.Text = "Untitled" & c
    PictureFileX.Index = c
    myPictureFiles.Add Item:=PictureFileX, Key:="P" & PictureFileX.Index
    Set AddPictureFile = PictureFileX
End Function

Public Property Get Skills() As Collection
    Set Skills = mySkills
End Property

Public Property Get PictureFiles() As Collection
    Set PictureFiles = myPictureFiles
End Property

Public Property Get Left() As Integer
    Left = myLeft
End Property

Public Property Let Left(NewValue As Integer)
    myLeft = NewValue
End Property

Public Property Get Top() As Integer
    Top = myTop
End Property

Public Property Let Top(NewValue As Integer)
    myTop = NewValue
End Property

Public Property Get Width() As Integer
    Width = myWidth
End Property

Public Property Let Width(NewValue As Integer)
    myWidth = NewValue
End Property

Public Property Get Height() As Integer
    Height = myHeight
End Property

Public Property Let Height(NewValue As Integer)
    myHeight = NewValue
End Property
