VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Creature"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Version of Class
Private myVersion As Integer
' Unique index for this Creature
Private myIndex As Integer
' Name of this Creature
Private myName As String
' Comments for this Creature (can be used as Description)
Private myComments As String
' Race string for Creature (separated by anything)
Private myRace As String

' Flags for small checks
'   Bit0    On=Agressive (Can't Ignore when Encounter)
'   Bit1    On=Friendly
'   Bit2    On=DMControlled
'   Bit3    On=Guard (Can't Take Treasture)
'   Bit4    On=HadTurn
'   Bit5    On=ScarletLetter
'   Bit6    On=Male, Off=Female
'   Bit7    On=Required in Tome
Private myFlags As Byte

' Current status of Creature
'   Bit0    On=IsFrozen
'   Bit1-2  CombatRank 0=Random, 1=Back, 2=Middle, 3=Front
'   Bit3    On=IsSelected (UberWizard use only)
'   Bit4    On=IsInanimate
'   Bit5    Not Used
'   Bit6    On=IsAfraid (Morale Failure/Flees Combat)
'   Bit7    On=IsUnconscious
Private myStatus As Byte

' Current Eternium of Creature (only applicable for Spell Casters)
Private myEternium As Byte

' File name of Picture File (BMP) in /creature directory PLUS Portrait File Name (if applicable)
Private myPictureFile As String
' Top and Left of Face
Private myFaceTop As Integer
Private myFaceLeft As Integer
' Pointer to PictureBox (used only at RUN time, not saved)
Private myPic As Integer

' X and Y on Map for Encounter (where this Creature is NOW)
Private myMapX As Integer
Private myMapY As Integer
' Number from 0 to 4 for spot on tile (where this Creature is NOW)
Private myTileSpot As Byte
' X and Y on Grid for Combat (again, where at NOW)
Private myCol As Integer
Private myRow As Integer
' This is run-time only data
Private myMoveToX As Integer
Private myMoveToY As Integer
' Que of Steps from A* routine
' Run-time only data
Private myStepX() As Integer
Private myStepY() As Integer
Private myMaxStep As Integer
Private myNextStep As Integer
Private mySteps As Integer
' Run-time only: current qued runes
Private myRunes(5) As Integer
Private myRuneTop As Integer
Private myRuneQueLimit As Integer
' Run-time only: Initiative of Creature
Private myInitiative As Integer
' Run-time only: Facing of Creature Picture in Combat
Private myFacing As Integer
' Run-time only: current Action Points of Creature
Private myActionPoints As Integer
' Run-time only: Bonus to General Resistance (0) and ResistanceTypes (1-8).
Private myResistanceBonus(8) As Integer
' Run-Time only: CreatureTarget (for me)
Private myCreatureTarget As Creature
' Run-Time only: Msg Que
Private myMsgQue(7) As String
Private myMsgQueTop As Integer

'   0 - Wing, 1 - Tail, 2 - Body, 3 - Head, 4 - Arm, 5 - Leg, 6 - Antenna
'   7 - Tentacle, 8 - Abdomen, 9 - Back, 10 - Neck
Private myBodyType(7) As Byte
' Armor Rank for each Armor chit (Percent Resistance)
Private myResistance(7) As Integer

' Resistance Type Bonus Values (Range from 0 to 100% by 10% increments)
Private myResistance1 As Byte
Private myResistance2 As Byte
Private myResistance3 As Byte
Private myResistance4 As Byte

' Default CombatAction (Right MouseButton)
Private myCombatAction1 As Integer
Private myCombatAction2 As Integer

Private myNotUsed2 As Byte

' Creature stats
Private myStrength As Byte
Private myWill As Byte
Private myAgility As Byte
Private myExperiencePoints As Long
Private mySkillPoints As Integer
' Run-time only: Creature Bonus Stats
Private myStrengthBonus As Integer
Private myWillBonus As Integer
Private myAgilityBonus As Integer
Private myAttackBonus As Integer
Private myDamageBonus As Integer
Private myDefenseBonus As Integer
Private myMovementCostBonus As Integer
' Run-time only: Current Combat Attitude
'   Bit0    On=Allowed Opportunity Attack, Off=Not Allowed
'   Bit1-4  Not Used
'   Bit5-7  Current Combat Attitude 0 thru 15
Private myCombatAttitude As Byte

Private myTempSkillSet As Integer
Private myTempSkillSpend As Integer

Private myLevel As Byte
Private myHPNow As Integer
Private myHPMax As Integer
Private myLunacy As Byte
Private myRevelry As Byte
Private myWrath As Byte
Private myPride As Byte
Private myGreed As Byte
Private myLust As Byte

' More Flags
'   Bit1    On=MoveWAV one time, Off=Many
'   Bit2    On=DieWAV one time, Off=Many
'   Bit3    On=AttackWAV one time, Off=Many
'   Bit4    On=HitWAV one time, Off=Many
'   Bit5    On=On Adventure, Off=Available
'   Bit6-8  Not Used
Private myFlagsWAV As Byte
' Sound files
Private myMoveWAV As String
Private myDieWAV As String
Private myAttackWAV As String
Private myHitWAV As String

' Family type
'Private Const bdSentient = &H1
'Private Const bdReptile = &H2
'Private Const bdInsect = &H4
'Private Const bdBlob = &H8
'Private Const bdAnimal = &HF
'Private Const bdVeggie = &H10
'Private Const bdBird = &H20
'Private Const bdUndead = &H40
'Private Const bdAquatic = &H80
'Private Const bdMagical = &HF0
Private myFamily As Integer

' Size of Creature
' Bit 0     -   On = Tiny
' Bit 1     -   On = Small
' Bit 2     -   On = Medium
' Bit 3     -   On = Large
' Bit 4     -   On = Huge
' Bit 5-7   -   Not Used
Private mySize As Byte

' Items held by this Creature
Private myItems As New Collection
' Triggers attached to this Creature
Private myTriggers As New Collection
' Conversations attached to this Creature
Private myConversations As New Collection
' Current Conversation Index for the Creature (0 is nothing current)
Private myCurrentConvo As Integer

Public Property Get Index() As Integer
    Index = myIndex
End Property

Public Property Let Index(NewIndex As Integer)
    myIndex = NewIndex
End Property

Public Property Get Initiative() As Integer
    Initiative = myInitiative
End Property

Public Property Let Initiative(NewValue As Integer)
    myInitiative = NewValue
End Property

Public Property Get Name() As String
    Name = Trim(myName)
End Property

Public Property Let Name(NewName As String)
    myName = Trim(NewName)
End Property

Public Property Get Comments() As String
    Comments = Trim(myComments)
End Property

Public Property Let Comments(NewComments As String)
    myComments = Trim(NewComments)
End Property

Public Property Get Race() As String
    Race = Trim(myRace)
End Property

Public Property Let Race(NewValue As String)
    myRace = Trim(NewValue)
End Property

Public Property Get MoveWAV() As String
    MoveWAV = Trim(myMoveWAV)
End Property

Public Property Let MoveWAV(NewMoveWAV As String)
    myMoveWAV = Trim(NewMoveWAV)
End Property

Public Property Get DieWAV() As String
    DieWAV = Trim(myDieWAV)
End Property

Public Property Let DieWAV(NewDieWAV As String)
    myDieWAV = Trim(NewDieWAV)
End Property

Public Property Get HitWAV() As String
    HitWAV = Trim(myHitWAV)
End Property

Public Property Let HitWAV(NewHitWAV As String)
    myHitWAV = Trim(NewHitWAV)
End Property

Public Property Get AttackWAV() As String
    AttackWAV = Trim(myAttackWAV)
End Property

Public Property Let AttackWAV(NewAttackWAV As String)
    myAttackWAV = Trim(NewAttackWAV)
End Property

Public Property Get MoveWAVOneTime() As Integer
    MoveWAVOneTime = (myFlagsWAV And &H1) > 0
End Property

Public Property Let MoveWAVOneTime(NewValue As Integer)
    If NewValue Then
        myFlagsWAV = myFlagsWAV Or &H1
    Else
        myFlagsWAV = myFlagsWAV And (Not &H1)
    End If
End Property

Public Property Get DieWAVOneTime() As Integer
    DieWAVOneTime = (myFlagsWAV And &H2) > 0
End Property

Public Property Let DieWAVOneTime(NewValue As Integer)
    If NewValue Then
        myFlagsWAV = myFlagsWAV Or &H2
    Else
        myFlagsWAV = myFlagsWAV And (Not &H2)
    End If
End Property

Public Property Get AttackWAVOneTime() As Integer
    AttackWAVOneTime = (myFlagsWAV And &H4) > 0
End Property

Public Property Let AttackWAVOneTime(NewValue As Integer)
    If NewValue Then
        myFlagsWAV = myFlagsWAV Or &H4
    Else
        myFlagsWAV = myFlagsWAV And (Not &H4)
    End If
End Property

Public Property Get HitWAVOneTime() As Integer
    HitWAVOneTime = (myFlagsWAV And &H8) > 0
End Property

Public Property Let HitWAVOneTime(NewValue As Integer)
    If NewValue Then
        myFlagsWAV = myFlagsWAV Or &H8
    Else
        myFlagsWAV = myFlagsWAV And (Not &H8)
    End If
End Property

Public Property Get CurrentConvo() As Integer
    CurrentConvo = myCurrentConvo
End Property

Public Property Let CurrentConvo(NewValue As Integer)
    myCurrentConvo = NewValue
End Property

Public Property Get MsgQueTop() As Integer
    MsgQueTop = myMsgQueTop
End Property

Public Property Let MsgQueTop(NewValue As Integer)
    myMsgQueTop = NewValue
End Property

Public Property Get MsgQue(Index As Integer) As String
    MsgQue = myMsgQue(Index)
End Property

Public Property Let MsgQue(Index As Integer, NewValue As String)
    myMsgQue(Index) = NewValue
End Property

Public Sub AddStep(NewX As Integer, NewY As Integer)
    Dim c As Integer
    ' Preserve previous steps
    ReDim KeepX(myMaxStep) As Integer
    ReDim KeepY(myMaxStep) As Integer
    If myMaxStep > 0 Then
        For c = 0 To myMaxStep
            KeepX(c) = myStepX(c)
            KeepY(c) = myStepY(c)
        Next c
    End If
    ' Resize for adding a step
    myMaxStep = myMaxStep + 1
    ReDim myStepX(myMaxStep) As Integer
    ReDim myStepY(myMaxStep) As Integer
    ' Replace previous steps
    For c = 0 To myMaxStep - 1
        myStepX(c) = KeepX(c)
        myStepY(c) = KeepY(c)
    Next c
    ' Add new step
    myStepX(myMaxStep) = NewX
    myStepY(myMaxStep) = NewY
End Sub

Public Sub NextStep(ByRef x As Integer, ByRef y As Integer)
    If myMaxStep > 0 Then
        x = myStepX(myMaxStep): y = myStepY(myMaxStep)
        myMaxStep = myMaxStep - 1
    Else
        x = myMapX: y = myMapY
    End If
End Sub

Public Property Get MoveToX() As Integer
    MoveToX = myMoveToX
End Property

Public Property Let MoveToX(NewValue As Integer)
    myMaxStep = 0
    ReDim myStepX(0) As Integer
    ReDim myStepY(0) As Integer
    myMoveToX = NewValue
End Property

Public Property Get MoveToY() As Integer
    MoveToY = myMoveToY
End Property

Public Property Let MoveToY(NewValue As Integer)
    myMaxStep = 0
    ReDim myStepX(0) As Integer
    ReDim myStepY(0) As Integer
    myMoveToY = NewValue
End Property

Public Property Get ItemMaxRange() As Integer
    ItemMaxRange = ItemInHand.MaxRange
End Property

Public Property Get ItemMinRange() As Integer
    ItemMinRange = ItemInHand.MinRange
End Property

Public Property Get ItemAmmo() As Item
    Dim ItemA As Item, ItemH As Item, ItemX As Item, ItemZ As Item
    Set ItemH = Me.ItemInHand
    If ItemH.IsShooter = True Then
        ' Search through equipped first
        For Each ItemX In myItems
            If ItemX.IsReady = True Then
                ' See if item itself is ammo
                If ItemX.IsAmmo = True And ItemX.ShootType = ItemH.ShootType Then
                    Set ItemAmmo = ItemX
                    Exit Property
                Else
                    ' Search inside the item for ammo
                    For Each ItemZ In ItemX.Items
                        If ItemZ.IsAmmo = True And ItemZ.ShootType = ItemH.ShootType Then
                            Set ItemAmmo = ItemZ
                            Exit Property
                        End If
                    Next ItemZ
                End If
            End If
        Next ItemX
        ' Unequipped next
        For Each ItemX In myItems
            If ItemX.IsReady = False Then
                ' See if item itself is ammo
                If ItemX.IsAmmo = True And ItemX.ShootType = ItemH.ShootType Then
                    Set ItemAmmo = ItemX
                    Exit Property
                Else
                    ' Search inside the item for ammo
                    For Each ItemZ In ItemX.Items
                        If ItemZ.IsAmmo = True And ItemZ.ShootType = ItemH.ShootType Then
                            Set ItemAmmo = ItemZ
                            Exit Property
                        End If
                    Next ItemZ
                End If
            End If
        Next ItemX
    End If
    Set ItemAmmo = ItemH
End Property

Public Property Get ItemInHand() As Item
    Dim ItemX As Item, ItemZ As Item
    For Each ItemX In myItems
        If ItemX.IsReady And ItemX.InHand Then
            Set ItemInHand = ItemX
            Exit Property
        End If
    Next ItemX
    Set ItemInHand = New Item
    ItemInHand.Name = "Hand"
    ItemInHand.Damage = 1
End Property

Public Sub UseAmmo()
    Dim ItemAmmo As Item, ItemX As Item, ItemZ As Item
    Dim Found As Integer
    Set ItemAmmo = Me.ItemAmmo
    If ItemAmmo.IsAmmo = True Then
        If ItemAmmo.Count = 1 Then
            ' Search through equipped first
            For Each ItemX In myItems
                If ItemX.Name = ItemAmmo.Name And ItemX.Index = ItemAmmo.Index Then
                    Me.RemoveItem "I" & ItemX.Index
                    Exit Sub
                End If
                For Each ItemZ In ItemX.Items
                    If ItemZ.Name = ItemAmmo.Name And ItemZ.Index = ItemAmmo.Index Then
                        ItemX.RemoveItem "I" & ItemZ.Index
                        Exit Sub
                    End If
                Next ItemZ
            Next ItemX
        Else
            ItemAmmo.Bulk = ItemAmmo.Bulk - Int(ItemAmmo.Bulk / ItemAmmo.Count)
            ItemAmmo.Weight = ItemAmmo.Weight - Int(ItemAmmo.Weight / ItemAmmo.Count)
            ItemAmmo.Value = ItemAmmo.Value - Int(ItemAmmo.Value / ItemAmmo.Count)
            ItemAmmo.Count = ItemAmmo.Count - 1
        End If
    ElseIf ItemAmmo.Family = 8 Then ' Thrown item
        ' Weapon (Thrown) self distructs
        If ItemAmmo.Count = 1 Then
            Me.RemoveItem "I" & ItemAmmo.Index
        Else
            ItemAmmo.Count = ItemAmmo.Count - 1
        End If
    End If
End Sub

Public Property Get Items() As Collection
    Set Items = myItems
End Property

Public Function AddItem() As Item
    ' Adds an Item and returns a reference to that Item
    Dim c As Integer
    Dim ItemX As Item
    ' Find new available unused index idenifier
    c = 1
    For Each ItemX In myItems
        If ItemX.Index >= c Then
            c = ItemX.Index + 1
        End If
    Next ItemX
    ' Set the index and add the door. Return the new door's index.
    Set ItemX = New Item
    ItemX.Index = c
    ItemX.Name = "Item" & c
    myItems.Add Item:=ItemX, Key:="I" & ItemX.Index
    Set AddItem = ItemX
End Function

Public Function AddItemBefore(BeforeKey As String) As Item
    ' Adds an Item and returns a reference to that Item
    Dim c As Integer
    Dim ItemX As Item
    ' Find new available unused index idenifier
    c = 1
    For Each ItemX In myItems
        If ItemX.Index >= c Then
            c = ItemX.Index + 1
        End If
    Next ItemX
    ' Set the index and add the door. Return the new door's index.
    Set ItemX = New Item
    ItemX.Index = c
    ItemX.Name = "Item" & c
    myItems.Add Item:=ItemX, Key:="I" & ItemX.Index, Before:=BeforeKey
    Set AddItemBefore = ItemX
End Function

Public Sub RemoveItem(DeleteKey As String)
    myItems.Remove DeleteKey
End Sub

Public Property Get Triggers() As Collection
    Set Triggers = myTriggers
End Property

Public Function AddTrigger() As Trigger
    ' Adds an Item and returns a reference to that Item
    Dim c As Integer
    Dim TriggerX As Trigger
    ' Find new available unused index identifier
    c = 1
    For Each TriggerX In myTriggers
        If TriggerX.Index >= c Then
            c = TriggerX.Index + 1
        End If
    Next TriggerX
    ' Set the index and add the door. Return the new door's index.
    Set TriggerX = New Trigger
    TriggerX.Index = c
    TriggerX.Name = "Trigger" & c
    myTriggers.Add Item:=TriggerX, Key:="T" & TriggerX.Index
    Set AddTrigger = TriggerX
End Function

Public Sub RemoveTrigger(DeleteKey As String)
    myTriggers.Remove DeleteKey
End Sub

Public Property Get Conversations() As Collection
    Set Conversations = myConversations
End Property

Public Function AddConversation() As Conversation
    ' Adds a Conversation and returns a reference to that Conversation
    Dim c As Integer
    Dim ConversationX As Conversation
    ' Find new available unused index idenifier
    c = 1
    For Each ConversationX In myConversations
        If ConversationX.Index >= c Then
            c = ConversationX.Index + 1
        End If
    Next ConversationX
    ' Create the Conversation, set the Index and add it.
    Set ConversationX = New Conversation
    ConversationX.Index = c
    ConversationX.Name = "Convo" & c
    myConversations.Add Item:=ConversationX, Key:="C" & ConversationX.Index
    Set AddConversation = ConversationX
End Function

Public Sub RemoveConversation(DeleteKey As String)
    If myConversations(DeleteKey).Index = myCurrentConvo Then
        myCurrentConvo = 0
    End If
    myConversations.Remove DeleteKey
End Sub

Public Property Get MovementRange() As Integer
    MovementRange = Int(Me.ActionPoints / Me.MovementCost)
End Property

Public Property Get MovementCost() As Integer
    Select Case Me.Agility
        Case 0 To 4
            MovementCost = 6
        Case 5 To 9
            MovementCost = 5
        Case 10 To 14
            MovementCost = 4
        Case 15 To 19
            MovementCost = 3
        Case 20 To 24
            MovementCost = 2
        Case Else
            MovementCost = 1
    End Select
    ' Penalty if total weight is near or over max
    If Me.Weight > Me.MaxWeight * 0.95 Then
        MovementCost = MovementCost + 2
    End If
    ' Add in MovementCostBonus
    MovementCost = MovementCost - Me.MovementCostBonus
    If MovementCost < 1 Then
        MovementCost = 1
    End If
End Property

Public Property Get MovementCostBonus() As Integer
    MovementCostBonus = myMovementCostBonus
End Property

Public Property Let MovementCostBonus(NewValue As Integer)
    myMovementCostBonus = NewValue
End Property

Public Property Get Friendly() As Integer
    Friendly = (myFlags And &H2) > 0
End Property

Public Property Let Friendly(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H2
    Else
        myFlags = myFlags And (Not &H2)
    End If
End Property

Public Property Get DMControlled() As Integer
    DMControlled = (myFlags And &H4) > 0
End Property

Public Property Let DMControlled(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H4
    Else
        myFlags = myFlags And (Not &H4)
    End If
End Property

Public Property Get Guard() As Integer
    Guard = (myFlags And &H8) > 0
End Property

Public Property Let Guard(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H8
    Else
        myFlags = myFlags And (Not &H8)
    End If
End Property

Public Property Get IsSelected() As Integer
    IsSelected = (myStatus And &H8) > 0
End Property

Public Property Let IsSelected(NewValue As Integer)
    If NewValue Then
        myStatus = myStatus Or &H8
    Else
        myStatus = myStatus And (Not &H8)
    End If
End Property

Public Property Get Agressive() As Integer
    Agressive = (myFlags And &H1) > 0
End Property

Public Property Let Agressive(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H1
    Else
        myFlags = myFlags And (Not &H1)
    End If
End Property

Public Property Get OpportunityAttack() As Integer
    OpportunityAttack = (myCombatAttitude And &H10) > 0
End Property

Public Property Let OpportunityAttack(NewValue As Integer)
    If NewValue Then
        myCombatAttitude = myCombatAttitude Or &H10
    Else
        myCombatAttitude = myCombatAttitude And (Not &H10)
    End If
End Property

Public Property Get CombatAttitude() As Integer
    CombatAttitude = (myCombatAttitude And &HF)
End Property

Public Property Let CombatAttitude(NewValue As Integer)
    myCombatAttitude = myCombatAttitude And (Not &HF)
    myCombatAttitude = myCombatAttitude Or NewValue
End Property

Public Property Get CombatAction1() As Integer
    CombatAction1 = myCombatAction1
End Property

Public Property Let CombatAction1(NewValue As Integer)
    myCombatAction1 = NewValue
End Property

Public Property Get CreatureTarget() As Creature
    Set CreatureTarget = myCreatureTarget
End Property

Public Property Let CreatureTarget(CreatureX As Creature)
    Set myCreatureTarget = CreatureX
End Property

Public Property Get CombatRank() As Integer
    CombatRank = (myStatus And &H6) / 2
End Property

Public Property Let CombatRank(NewValue As Integer)
    myStatus = myStatus And (Not &H6)
    myStatus = myStatus Or (NewValue * 2)
End Property

Public Property Get Frozen() As Integer
    Frozen = (myStatus And &H1) > 0
End Property

Public Property Let Frozen(NewValue As Integer)
    If NewValue Then
        myStatus = myStatus Or &H1
    Else
        myStatus = myStatus And (Not &H1)
    End If
End Property

Public Property Get Afraid() As Integer
    Afraid = (myStatus And &H40) > 0
End Property

Public Property Let Afraid(NewValue As Integer)
    If NewValue Then
        myStatus = myStatus Or &H40
    Else
        myStatus = myStatus And (Not &H40)
    End If
End Property

Public Property Get Pronoun(Index As Integer) As String
    Select Case Index
        Case 1
            If Me.Male = True Then
                Pronoun = "he"
            Else
                Pronoun = "she"
            End If
        Case 2
            If Me.Male = True Then
                Pronoun = "him"
            Else
                Pronoun = "her"
            End If
        Case 3
            If Me.Male = True Then
                Pronoun = "his"
            Else
                Pronoun = "her"
            End If
    End Select
End Property

Public Property Get HadTurn() As Integer
    HadTurn = (myFlags And &H10) > 0
End Property

Public Property Let HadTurn(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H10
    Else
        myFlags = myFlags And (Not &H10)
    End If
End Property

Public Property Get IsInanimate() As Integer
    IsInanimate = (myStatus And &H10) > 0
End Property

Public Property Let IsInanimate(NewValue As Integer)
    If NewValue Then
        myStatus = myStatus Or &H10
    Else
        myStatus = myStatus And (Not &H10)
    End If
End Property

Public Property Get RequiredInTome() As Integer
    RequiredInTome = (myFlags And &H80) > 0
End Property

Public Property Let RequiredInTome(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H80
    Else
        myFlags = myFlags And (Not &H80)
    End If
End Property

Public Property Get Unconscious() As Integer
    Unconscious = (myStatus And &H80) > 0
End Property

Public Property Let Unconscious(NewValue As Integer)
    If NewValue Then
        myStatus = myStatus Or &H80
    Else
        myStatus = myStatus And (Not &H80)
    End If
End Property

Public Property Get ScarletLetter() As Integer
    ScarletLetter = (myFlags And &H20) > 0
End Property

Public Property Let ScarletLetter(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H20
    Else
        myFlags = myFlags And (Not &H20)
    End If
End Property

Public Property Get Male() As Integer
    Male = (myFlags And &H40) > 0
End Property

Public Property Let Male(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H40
    Else
        myFlags = myFlags And (Not &H40)
    End If
End Property

Public Property Get Flags() As Integer
    Flags = myFlags
End Property

Public Property Let Flags(NewFlags As Integer)
    myFlags = NewFlags
End Property

Public Property Get Status() As Integer
    Status = myStatus
End Property

Public Property Let Status(NewStatus As Integer)
    myStatus = NewStatus
End Property

Public Property Get StatusText() As String
    If myHPNow < 1 Then
        StatusText = "Dead"
    ElseIf Me.Unconscious = True Then
        StatusText = "Unconscious"
    ElseIf Me.Frozen = True Then
        StatusText = "Frozen"
    ElseIf myActionPoints < 1 Then
        StatusText = "Exhausted"
    Else
        StatusText = "Ok"
    End If
End Property

Public Property Get Eternium() As Integer
    Eternium = myEternium
End Property

Public Property Let Eternium(NewValue As Integer)
    Dim c As Integer
    c = Me.EterniumMax
    If NewValue < 1 Then
        myEternium = 0
    ElseIf NewValue <= c Then
        myEternium = NewValue
    Else
        myEternium = c
    End If
End Property

Public Property Get EterniumMax() As Integer
    EterniumMax = myWill * 4
    If EterniumMax > 250 Then
        EterniumMax = 250
    End If
End Property

Public Property Get Runes(Index As Integer) As Integer
    Runes = myRunes(Index)
End Property

Public Property Let Runes(Index As Integer, NewValue As Integer)
    myRunes(Index) = NewValue
End Property

Public Property Get RuneTop() As Integer
    RuneTop = myRuneTop
End Property

Public Property Let RuneTop(NewValue As Integer)
    myRuneTop = NewValue
End Property

Public Property Get RuneQueLimit() As Integer
    RuneQueLimit = myRuneQueLimit
End Property

Public Property Let RuneQueLimit(NewValue As Integer)
    myRuneQueLimit = NewValue
End Property

Public Property Get PictureFile() As String
    PictureFile = Trim(BreakText(myPictureFile, 1))
End Property

Public Property Let PictureFile(NewValue As String)
    If Len(BreakText(myPictureFile, 2)) > 0 Then
        myPictureFile = Trim(NewValue) & "|" & BreakText(myPictureFile, 2)
    Else
        myPictureFile = Trim(NewValue)
    End If
End Property

Public Property Get PortraitFile() As String
    PortraitFile = Trim(BreakText(myPictureFile, 2))
End Property

Public Property Let PortraitFile(NewValue As String)
    myPictureFile = BreakText(myPictureFile, 1) & "|" & NewValue
End Property

Public Property Get OnAdventure() As Integer
    OnAdventure = (myFlagsWAV And &H20) > 0
End Property

Public Property Let OnAdventure(NewValue As Integer)
    If NewValue Then
        myFlagsWAV = myFlagsWAV Or &H20
    Else
        myFlagsWAV = myFlagsWAV And (Not &H20)
    End If
End Property

Public Property Get Pic() As Integer
    Pic = myPic
End Property

Public Property Let Pic(NewPic As Integer)
    myPic = NewPic
End Property

Public Property Get FaceLeft() As Integer
    FaceLeft = myFaceLeft
End Property

Public Property Let FaceLeft(NewFaceLeft As Integer)
    myFaceLeft = NewFaceLeft
End Property

Public Property Get FaceTop() As Integer
    FaceTop = myFaceTop
End Property

Public Property Let FaceTop(NewFaceTop As Integer)
    myFaceTop = NewFaceTop
End Property

Public Property Get MapX() As Integer
    MapX = myMapX
End Property

Public Property Let MapX(NewValue As Integer)
    myMapX = NewValue
End Property

Public Property Get MapY() As Integer
    MapY = myMapY
End Property

Public Property Let MapY(NewValue As Integer)
    myMapY = NewValue
End Property

Public Property Get Steps() As Integer
    Steps = mySteps
End Property

Public Property Let Steps(NewValue As Integer)
    mySteps = NewValue
End Property

Public Property Get TileSpotX() As Integer
    Select Case myTileSpot
        Case 0: TileSpotX = 32
        Case 1: TileSpotX = 20
        Case 2: TileSpotX = 8
        Case 3: TileSpotX = 44
        Case 4: TileSpotX = 32
        Case 5: TileSpotX = 20
        Case 7: TileSpotX = 44
        Case 6: TileSpotX = 56
        Case 8: TileSpotX = 32
    End Select
End Property

Public Property Get TileSpotY() As Integer
    Select Case myTileSpot
        Case 0: TileSpotY = 40
        Case 1: TileSpotY = 46
        Case 2: TileSpotY = 52
        Case 3: TileSpotY = 46
        Case 4: TileSpotY = 52
        Case 5: TileSpotY = 58
        Case 6: TileSpotY = 52
        Case 7: TileSpotY = 58
        Case 8: TileSpotY = 64
    End Select
End Property

Public Property Let TileSpot(NewValue As Integer)
    myTileSpot = NewValue
End Property

Public Property Get TileSpot() As Integer
    TileSpot = myTileSpot
End Property

Public Property Get Col() As Integer
    Col = myCol
End Property

Public Property Let Col(NewValue As Integer)
    myCol = NewValue
End Property

Public Property Get Row() As Integer
    Row = myRow
End Property

Public Property Let Row(NewValue As Integer)
    myRow = NewValue
End Property

Public Property Get Resistance(Index As Integer) As Integer
    ' Normal resistance: Index is location of hit (Body, Head, etc.)
    Resistance = myResistance(Index) + Me.ResistanceBonus(0)
End Property

Public Property Let Resistance(Index As Integer, NewResistance As Integer)
    myResistance(Index) = NewResistance
End Property

Public Property Get ResistanceBonus(Index As Integer) As Integer
    ' Bonus to resistance of various types: Index is 0 = General, 1 = Sharp, 2 = Blunt, etc.
    ResistanceBonus = myResistanceBonus(Index)
End Property

Public Property Let ResistanceBonus(Index As Integer, NewValue As Integer)
    myResistanceBonus(Index) = NewValue
End Property

Public Property Get DamageBonus() As Integer
    DamageBonus = myDamageBonus
End Property

Public Property Let DamageBonus(NewValue As Integer)
    myDamageBonus = NewValue
End Property

Public Property Get DefenseBonus() As Integer
    Dim c As Integer
    ' Modifier is based on the Creature's size
    ' Bit 0     -   On = Tiny (+4)
    ' Bit 1     -   On = Small (+2)
    ' Bit 2     -   On = Medium (0)
    ' Bit 3     -   On = Large (-2)
    ' Bit 4     -   On = Huge (-4)
    DefenseBonus = myDefenseBonus
    For c = 0 To 4
        If Me.Size(c) = True Then
            DefenseBonus = DefenseBonus + (2 - c) * 2
        End If
    Next c
End Property

Public Property Let DefenseBonus(NewValue As Integer)
    myDefenseBonus = NewValue
End Property

Public Property Get AttackBonus() As Integer
    AttackBonus = myAttackBonus + Fix((Me.Agility - 10) / 3)
End Property

Public Property Let AttackBonus(NewValue As Integer)
    myAttackBonus = NewValue
End Property

Public Property Get WillBonus() As Integer
    WillBonus = myWillBonus
End Property

Public Property Let WillBonus(NewValue As Integer)
    myWillBonus = NewValue
End Property

Public Property Get AgilityBonus() As Integer
    AgilityBonus = myAgilityBonus
End Property

Public Property Let AgilityBonus(NewValue As Integer)
    myAgilityBonus = NewValue
End Property

Public Property Get StrengthBonus() As Integer
    StrengthBonus = myStrengthBonus
End Property

Public Property Let StrengthBonus(NewValue As Integer)
    myStrengthBonus = NewValue
End Property

Public Property Get Lunacy() As Integer
    Lunacy = myLunacy
End Property

Public Property Let Lunacy(NewValue As Integer)
    myLunacy = NewValue
End Property

Public Property Get Revelry() As Integer
    Revelry = myRevelry
End Property

Public Property Let Revelry(NewValue As Integer)
    myRevelry = NewValue
End Property

Public Property Get Wrath() As Integer
    Wrath = myWrath
End Property

Public Property Let Wrath(NewValue As Integer)
    myWrath = NewValue
End Property

Public Property Get Pride() As Integer
    Pride = myPride
End Property

Public Property Let Pride(NewValue As Integer)
    myPride = NewValue
End Property

Public Property Get Greed() As Integer
    Greed = myGreed
End Property

Public Property Let Greed(NewValue As Integer)
    myGreed = NewValue
End Property

Public Property Get Lust() As Integer
    Lust = myLust
End Property

Public Property Let Lust(NewValue As Integer)
    myLust = NewValue
End Property

Public Property Get CombatAction2() As Integer
    CombatAction2 = myCombatAction2
End Property

Public Property Let CombatAction2(NewValue As Integer)
    myCombatAction2 = NewValue
End Property

Public Property Get ActionPointsMax() As Integer
    Dim ItemX As Item
    ActionPointsMax = Fix((myWill + myAgility + myStrength) / 3) + Me.Level
    For Each ItemX In myItems
        If ItemX.IsReady = True And ItemX.InHand = False Then
            ActionPointsMax = ActionPointsMax - ItemX.ActionPoints
        End If
    Next ItemX
End Property

Public Property Get ResistanceTypeBonus(Index As Integer) As Integer
    Dim b1 As Byte
    ' Special resistance to certain attacks: Index is 0 = Sharp, 1 = Blunt, etc.
    ' Returns an index:  0 = None, 1 = 10%, 2 = 20% ... 10 = 100%, 11 = Double Damage, 12 = Triple Damage
    b1 = 2 ^ Index
    ResistanceTypeBonus = Abs((myResistance1 And b1) > 0) + Abs((myResistance2 And b1) > 0) * 2 + Abs((myResistance3 And b1) > 0) * 4 + Abs((myResistance4 And b1) > 0) * 8
End Property

Public Property Let ResistanceTypeBonus(Index As Integer, NewValue As Integer)
    Dim b1 As Byte
    ' Index is 0 = Sharp, 1 = Blunt, etc.
    b1 = 2 ^ Index
    ' Clear the current value
    myResistance1 = myResistance1 And (Not b1)
    myResistance2 = myResistance2 And (Not b1)
    myResistance3 = myResistance3 And (Not b1)
    myResistance4 = myResistance4 And (Not b1)
    ' Set the new value
    Select Case NewValue
        Case 1, 3, 5, 7, 9, 11, 13, 15
            ' 0001
            myResistance1 = myResistance1 Or b1
    End Select
    Select Case NewValue
        Case 2, 3, 6, 7, 10, 11, 14, 15
            ' 0010
            myResistance2 = myResistance2 Or b1
    End Select
    Select Case NewValue
        Case 4, 5, 6, 7, 12, 13, 14, 15
            ' 0100
            myResistance3 = myResistance3 Or b1
    End Select
    Select Case NewValue
        Case 8, 9, 10, 11, 12, 13, 14, 15
            ' 1000
            myResistance4 = myResistance4 Or b1
    End Select
End Property

Public Property Get ResistanceWithArmor(Index As Integer) As Integer
    Dim ItemX As Item
    ' Index is location of hit: Body, Head, etc.
    ResistanceWithArmor = Me.Resistance(Index) + Me.ResistanceBonus(0)
    ' Add up Armor Resistance
    For Each ItemX In Me.Items
        If ItemX.IsReady = True Then
            Select Case Index
                Case 0 To 3 ' Body
                    If ItemX.WearType = 0 Then  ' Body
                        ResistanceWithArmor = ResistanceWithArmor + ItemX.Resistance
                    End If
                Case 4 To 5 ' Shield
                    If ItemX.WearType = 5 Then  ' Shield
                        ResistanceWithArmor = ResistanceWithArmor + ItemX.Resistance
                    End If
                Case 6      ' Head
                    If ItemX.WearType = 1 Then  ' Helm
                        ResistanceWithArmor = ResistanceWithArmor + ItemX.Resistance
                    End If
                Case 7      ' Neck (No Armor)
            End Select
        End If
    Next ItemX
End Property

Public Property Get ResistanceTypeWithArmor(DamageType As Integer) As Integer
    Dim ItemX As Item, c As Integer
    ' Damage type is:
    '       0 - None, 1 - Sharp, 2 - Blunt, 3 - Cold, 4 - Heat, 5 - Evil
    '       6 - Good, 7 - Energy, 8 - Mind
    If DamageType > 0 Then
        Select Case Me.ResistanceTypeBonus(DamageType - 1)
            Case 0 To 10
                ResistanceTypeWithArmor = Me.ResistanceTypeBonus(DamageType - 1) * 10
            Case 11
                ResistanceTypeWithArmor = -100
            Case 12
                ResistanceTypeWithArmor = -200
        End Select
        ' Add Bonus (if any)
        ResistanceTypeWithArmor = ResistanceTypeWithArmor + Me.ResistanceBonus(DamageType)
        ' Add up Armor Resistance
        For Each ItemX In Me.Items
            If ItemX.IsReady = True And ItemX.ResistanceType = DamageType Then
                Select Case ItemX.ResistanceBonus
                    Case 0 To 10
                        ResistanceTypeWithArmor = ResistanceTypeWithArmor + ItemX.ResistanceBonus * 10
                    Case 11
                        ResistanceTypeWithArmor = ResistanceTypeWithArmor - 100
                    Case 12
                        ResistanceTypeWithArmor = ResistanceTypeWithArmor - 200
                End Select
            End If
        Next ItemX
    End If
End Property

Public Property Get BodyType(Index As Integer) As Integer
    BodyType = myBodyType(Index)
End Property

Public Property Let BodyType(Index As Integer, NewValue As Integer)
    myBodyType(Index) = NewValue
End Property

Public Property Get Strength() As Integer
    Strength = myStrength + myStrengthBonus
End Property

Public Property Let Strength(NewStrength As Integer)
    myStrength = NewStrength
End Property

Public Property Get Will() As Integer
    Will = myWill + myWillBonus
End Property

Public Property Let Will(NewWill As Integer)
    myWill = NewWill
End Property

Public Property Get Agility() As Integer
    Agility = myAgility + myAgilityBonus
End Property

Public Property Let Agility(NewAgility As Integer)
    myAgility = NewAgility
End Property

Public Property Get Facing() As Integer
    Facing = myFacing
End Property

Public Property Let Facing(NewValue As Integer)
    myFacing = NewValue
End Property

Public Property Get AllowedTurn() As Integer
    If myHPNow > 0 And Me.Unconscious = False And Me.Frozen = False And Me.Afraid = False And Me.IsInanimate = False Then
        AllowedTurn = True
    Else
        AllowedTurn = False
    End If
End Property

Public Property Get IsSpellCaster() As Integer
    Dim TriggerX As Trigger, StatementX As Statement
    IsSpellCaster = False
    For Each TriggerX In myTriggers
        If TriggerX.TriggerType = 39 Then ' OnSkillUse Trigger
            For Each StatementX In TriggerX.Statements
                If StatementX.Statement = 47 Then   ' Sorcery Statement
                    IsSpellCaster = True
                    Exit For
                End If
            Next StatementX
        End If
    Next TriggerX
End Property

Public Property Get Money() As Long
    Dim ItemX As Item
    Money = 0
    For Each ItemX In Me.Items
        Money = Money + ItemX.Money
    Next ItemX
End Function

Public Property Let Money(NewValue As Long)
    Const bdMoneyType = 2
    Dim ItemX As Item
    Dim c As Long
    
    If NewValue > Me.Money Then
        ' Add Money
        c = NewValue - Me.Money
        For Each ItemX In Me.Items
            If ItemX.Family = bdMoneyType And (ItemX.Value / ItemX.Count) = 1 Then
                ItemX.Value = ItemX.Value + c
                ItemX.Count = ItemX.Count + c
                Exit Property
            End If
        Next ItemX
        ' Didn't find Money, so create some
        Set ItemX = Me.AddItem
        ItemX.Name = "Gold Coin"
        ItemX.Family = bdMoneyType
        ItemX.Value = c
        ItemX.Count = c
        ItemX.Weight = c
        ItemX.Bulk = Greatest(CInt(c / 10), 1)
        ItemX.CanCombine = True
        ItemX.PictureFile = "gold1.bmp"
    ElseIf NewValue < Me.Money Then
        ' Remove Money
        c = Me.Money - NewValue
        For Each ItemX In Me.Items
            If ItemX.RemoveMoney(CInt(c)) = True Then
                Me.RemoveItem "I" & ItemX.Index
            End If
        Next ItemX
    End If
End Property

Public Property Get ActionPoints() As Integer
    ActionPoints = myActionPoints
End Property

Public Property Let ActionPoints(NewValue As Integer)
    If NewValue < 1 Then
        myActionPoints = 0
    ElseIf NewValue > 255 Then
        myActionPoints = 255
    Else
        myActionPoints = NewValue
    End If
End Property

Public Property Get ExperiencePoints() As Long
    ExperiencePoints = myExperiencePoints
End Property

Public Property Let ExperiencePoints(NewValue As Long)
    myExperiencePoints = NewValue
End Property

Public Property Get SkillPoints() As Integer
    SkillPoints = mySkillPoints
End Property

Public Property Let SkillPoints(NewValue As Integer)
    mySkillPoints = NewValue
End Property

Public Property Get TempSkillSet() As Integer
    TempSkillSet = myTempSkillSet
End Property

Public Property Let TempSkillSet(NewValue As Integer)
    myTempSkillSet = NewValue
End Property

Public Property Get TempSkillSpend() As Integer
    TempSkillSpend = myTempSkillSpend
End Property

Public Property Let TempSkillSpend(NewValue As Integer)
    myTempSkillSpend = NewValue
End Property

Public Property Get Level() As Integer
    Level = myLevel
End Property

Public Property Let Level(NewLevel As Integer)
    myLevel = NewLevel
    If myLevel < 1 Then
        myLevel = 1
    End If
End Property

Public Property Get EncounterPoints() As Integer
    Select Case myLevel
        Case 0 To 1
            EncounterPoints = 1
        Case 2
            EncounterPoints = 2
        Case 3
            EncounterPoints = 3
        Case 4
            EncounterPoints = 4
        Case 5
            EncounterPoints = 5
        Case 6
            EncounterPoints = 10
        Case 7
            EncounterPoints = 15
        Case 8
            EncounterPoints = 20
        Case 9
            EncounterPoints = 30
        Case Else
            EncounterPoints = 75
    End Select
End Property

Public Property Get HPNow() As Integer
    HPNow = myHPNow
End Property

Public Property Let HPNow(NewValue As Integer)
    myHPNow = NewValue
    If myHPNow > myHPMax Then
        myHPNow = myHPMax
    End If
End Property

Public Property Get HPMax() As Integer
    HPMax = myHPMax
End Property

Public Property Let HPMax(NewHPMax As Integer)
    myHPMax = NewHPMax
End Property

Public Property Get Weight() As Integer
    Dim ItemX As Item, c As Integer
    c = 0
    For Each ItemX In myItems
        c = c + ItemX.Weight
    Next ItemX
    Weight = c
End Property

Public Property Get MaxWeight() As Integer
    MaxWeight = myStrength * 15
End Property

Public Property Get Bulk() As Integer
    Dim ItemX As Item, c As Double
    c = 0
    For Each ItemX In myItems
        If ItemX.IsReady = False Then
            c = c + ItemX.Bulk
        End If
    Next ItemX
    Bulk = c
End Property

Public Property Get Defense() As Integer
    Dim ItemX As Item
    Defense = 13 + Me.DefenseBonus
    ' Modify based on current Health
    If Me.HPNow > 0 And Me.HPNow < Me.HPMax Then
        Defense = Defense - 3 + Round((Me.HPNow / Me.HPMax) * 3)
    End If
    ' Modify based on what you're wearing
    For Each ItemX In Me.Items
        ' If wearing and not an InHand type item
        If ItemX.IsReady = True Then
            Defense = Defense + ItemX.Defense
        End If
    Next ItemX
    If Defense < 0 Then
        Defense = 1
    End If
End Property

Public Property Get Family(Check As Integer) As Integer
    Family = (myFamily And (2 ^ Check)) > 0
End Property

Public Property Let Family(Check As Integer, NewValue As Integer)
    If NewValue Then
        myFamily = myFamily Or (2 ^ Check)
    Else
        myFamily = myFamily And (Not (2 ^ Check))
    End If
End Property

Public Property Get Size(Check As Integer) As Integer
    Size = (mySize And (2 ^ Check)) > 0
End Property

Public Property Let Size(Check As Integer, NewValue As Integer)
    If NewValue Then
        mySize = mySize Or (2 ^ Check)
    Else
        mySize = mySize And (Not (2 ^ Check))
    End If
End Property

Public Sub Copy(FromCreature As Creature)
    Dim c As Integer, i As Integer
    Dim myTrigger As Trigger, myItem As Item
    Dim ConversationX As Conversation
    myName = FromCreature.Name
    myComments = FromCreature.Comments
    myRace = FromCreature.Race
    myFlags = FromCreature.Flags
    myStatus = FromCreature.Status
    myEternium = FromCreature.Eternium
    myPictureFile = FromCreature.PictureFile
    myPic = FromCreature.Pic
    myFaceTop = FromCreature.FaceTop
    myFaceLeft = FromCreature.FaceLeft
    For c = 0 To 7
        myResistance(c) = FromCreature.Resistance(c)
        myBodyType(c) = FromCreature.BodyType(c)
    Next c
    For c = 0 To 7
        Me.ResistanceTypeBonus(c) = FromCreature.ResistanceTypeBonus(c)
    Next c
    myStrength = FromCreature.Strength
    myWill = FromCreature.Will
    myAgility = FromCreature.Agility
    myActionPoints = FromCreature.ActionPoints
    myExperiencePoints = FromCreature.ExperiencePoints
    mySkillPoints = FromCreature.SkillPoints
    myLevel = FromCreature.Level
    myHPNow = FromCreature.HPNow
    myHPMax = FromCreature.HPMax
    myLunacy = FromCreature.Lunacy
    myRevelry = FromCreature.Revelry
    myWrath = FromCreature.Wrath
    myPride = FromCreature.Pride
    myGreed = FromCreature.Greed
    myLust = FromCreature.Lust
    myCombatAction2 = FromCreature.CombatAction2
    myMoveWAV = FromCreature.MoveWAV
    myDieWAV = FromCreature.DieWAV
    myAttackWAV = FromCreature.AttackWAV
    myHitWAV = FromCreature.HitWAV
    Me.MoveWAVOneTime = FromCreature.MoveWAVOneTime
    Me.DieWAVOneTime = FromCreature.DieWAVOneTime
    Me.AttackWAVOneTime = FromCreature.AttackWAVOneTime
    Me.HitWAVOneTime = FromCreature.HitWAVOneTime
    For c = 0 To 9
        Me.Family(c) = FromCreature.Family(c)
    Next c
    For c = 0 To 4
        Me.Size(c) = FromCreature.Size(c)
    Next c
    ' Copy Items for Creature
    Set myItems = New Collection
    For c = 1 To FromCreature.Items.Count
        Set myItem = Me.AddItem
        myItem.Copy FromCreature.Items(c)
    Next c
    ' Copy Triggers for Creature
    myCurrentConvo = FromCreature.CurrentConvo
    Set myTriggers = New Collection
    For c = 1 To FromCreature.Triggers.Count
        Set myTrigger = Me.AddTrigger
        myTrigger.Copy FromCreature.Triggers(c)
    Next c
    ' Copy Conversation for Creature
    Set myConversations = New Collection
    For c = 1 To FromCreature.Conversations.Count
        Set ConversationX = Me.AddConversation
        ConversationX.Copy FromCreature.Conversations(c)
    Next c
End Sub

Public Sub ReadFromFileHeader(FromFile As Integer)
    Dim c As Integer, Cnt As Long
    ' Read Item Name, Index and Comments
    Get FromFile, , myVersion
    Get FromFile, , Cnt
    myName = ""
    For c = 1 To Cnt
        myName = myName & " "
    Next c
    Get FromFile, , myName
    Get FromFile, , myIndex
    ' Read Comments
    Get FromFile, , Cnt
    myComments = ""
    For c = 1 To Cnt
        myComments = myComments & " "
    Next c
    Get FromFile, , myComments
    Get FromFile, , Cnt
    myRace = ""
    For c = 1 To Cnt
        myRace = myRace & " "
    Next c
    Get FromFile, , myRace
    Get FromFile, , myFlags
    Get FromFile, , myStatus
    Get FromFile, , myEternium
    Get FromFile, , Cnt
    myPictureFile = ""
    For c = 1 To Cnt
        myPictureFile = myPictureFile & " "
    Next c
    Get FromFile, , myPictureFile
    Get FromFile, , myFaceLeft
    Get FromFile, , myFaceTop
    Get FromFile, , myMapX
    Get FromFile, , myMapY
    Get FromFile, , myTileSpot
    For c = 0 To 7
        Get FromFile, , myResistance(c)
        Get FromFile, , myBodyType(c)
    Next c
    Get FromFile, , myResistance1
    Get FromFile, , myResistance2
    Get FromFile, , myResistance3
    Get FromFile, , myResistance4
    Get FromFile, , myStrength
    Get FromFile, , myWill
    Get FromFile, , myAgility
    Get FromFile, , myNotUsed2
    Get FromFile, , myExperiencePoints
    Get FromFile, , mySkillPoints
    Get FromFile, , myLevel
    Get FromFile, , myHPNow
    Get FromFile, , myHPMax
End Sub

Public Sub ReadFromFile(FromFile As Integer)
    Dim c As Integer, Cnt As Long
    Dim myItem As Item, myTrigger As Trigger
    Dim ConversationX As Conversation
    ReadFromFileHeader FromFile
    ' Read other stats
    Get FromFile, , myLunacy
    Get FromFile, , myRevelry
    Get FromFile, , myWrath
    Get FromFile, , myPride
    Get FromFile, , myGreed
    Get FromFile, , myLust
    Get FromFile, , myCombatAction1
    Get FromFile, , myCombatAction2
    Get FromFile, , myFamily
    Get FromFile, , mySize
    ' Read WAV file names
    Get FromFile, , Cnt
    myMoveWAV = ""
    For c = 1 To Cnt
        myMoveWAV = myMoveWAV & " "
    Next c
    Get FromFile, , myMoveWAV
    Get FromFile, , Cnt
    myDieWAV = ""
    For c = 1 To Cnt
        myDieWAV = myDieWAV & " "
    Next c
    Get FromFile, , myDieWAV
    Get FromFile, , Cnt
    myAttackWAV = ""
    For c = 1 To Cnt
        myAttackWAV = myAttackWAV & " "
    Next c
    Get FromFile, , myAttackWAV
    Get FromFile, , Cnt
    myHitWAV = ""
    For c = 1 To Cnt
        myHitWAV = myHitWAV & " "
    Next c
    Get FromFile, , myHitWAV
    Get FromFile, , myFlagsWAV
    ' Read Items
    Get FromFile, , Cnt
    For c = 1 To Cnt
        Set myItem = New Item
        myItem.ReadFromFile FromFile
        myItems.Add Item:=myItem, Key:="I" & myItem.Index
    Next c
    ' Read Triggers
    Get FromFile, , Cnt
    For c = 1 To Cnt
        Set myTrigger = New Trigger
        myTrigger.ReadFromFile FromFile
        myTriggers.Add Item:=myTrigger, Key:="T" & myTrigger.Index
    Next c
    ' Read Conversations
    Get FromFile, , myCurrentConvo
    Get FromFile, , Cnt
    For c = 1 To Cnt
        Set ConversationX = New Conversation
        ConversationX.ReadFromFile FromFile
        myConversations.Add Item:=ConversationX, Key:="C" & ConversationX.Index
    Next c
End Sub

Public Sub SaveToFile(ToFile As Integer)
    Dim c As Integer
    Put ToFile, , myVersion
    Put ToFile, , Len(myName)
    Put ToFile, , myName
    Put ToFile, , myIndex
    Put ToFile, , Len(myComments)
    Put ToFile, , myComments
    Put ToFile, , Len(myRace)
    Put ToFile, , myRace
    Put ToFile, , myFlags
    Put ToFile, , myStatus
    Put ToFile, , myEternium
    Put ToFile, , Len(myPictureFile)
    Put ToFile, , myPictureFile
    Put ToFile, , myFaceLeft
    Put ToFile, , myFaceTop
    Put ToFile, , myMapX
    Put ToFile, , myMapY
    Put ToFile, , myTileSpot
    For c = 0 To 7
        Put ToFile, , myResistance(c)
        Put ToFile, , myBodyType(c)
    Next c
    Put ToFile, , myResistance1
    Put ToFile, , myResistance2
    Put ToFile, , myResistance3
    Put ToFile, , myResistance4
    Put ToFile, , myStrength
    Put ToFile, , myWill
    Put ToFile, , myAgility
    Put ToFile, , myNotUsed2
    Put ToFile, , myExperiencePoints
    Put ToFile, , mySkillPoints
    Put ToFile, , myLevel
    Put ToFile, , myHPNow
    Put ToFile, , myHPMax
    Put ToFile, , myLunacy
    Put ToFile, , myRevelry
    Put ToFile, , myWrath
    Put ToFile, , myPride
    Put ToFile, , myGreed
    Put ToFile, , myLust
    Put ToFile, , myCombatAction1
    Put ToFile, , myCombatAction2
    Put ToFile, , myFamily
    Put ToFile, , mySize
    ' Save WAV File names
    Put ToFile, , Len(myMoveWAV)
    Put ToFile, , myMoveWAV
    Put ToFile, , Len(myDieWAV)
    Put ToFile, , myDieWAV
    Put ToFile, , Len(myAttackWAV)
    Put ToFile, , myAttackWAV
    Put ToFile, , Len(myHitWAV)
    Put ToFile, , myHitWAV
    Put ToFile, , myFlagsWAV
    ' Save Items
    Put ToFile, , myItems.Count
    For c = 1 To myItems.Count
        myItems(c).SaveToFile ToFile
    Next c
    ' Save Triggers
    Put ToFile, , myTriggers.Count
    For c = 1 To myTriggers.Count
        myTriggers(c).SaveToFile ToFile
    Next c
    ' Save Conversations
    Put ToFile, , myCurrentConvo
    Put ToFile, , myConversations.Count
    For c = 1 To myConversations.Count
        myConversations(c).SaveToFile ToFile
    Next c
End Sub

Private Sub Class_Initialize()
    myName = "Creature"
    Me.DMControlled = True
    Me.Agressive = True
    Me.Guard = True
    Me.Friendly = False
    Me.Male = True
    Me.Family(0) = True
    myHPNow = 25: myHPMax = 25
    myStrength = 10: myWill = 10: myAgility = 10
    myLunacy = 18: myRevelry = 18: myWrath = 18: myPride = 18: myGreed = 18: myLust = 18
    myLevel = 1
    myMaxStep = 0
    myNextStep = 0
    myBodyType(0) = 2
    myBodyType(1) = 2
    myBodyType(2) = 2
    myBodyType(3) = 2
    myBodyType(4) = 4
    myBodyType(5) = 4
    myBodyType(6) = 3
    myBodyType(7) = 10
End Sub
