VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Plot"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Version number of Class
Private myVersion As Integer
' Password protection
Private myPassword As String
' Plot is an Object which holds one or more EncounterMaps
Private myMaps As New Collection

Public Function AddMapWithIndex(Index As Integer) As Map
    'Adds a Map and returns a reference to that Map
    Dim c As Integer
    Dim MapX As Map
    ' Set the index and add the map. Return the new map's index.
    Set MapX = New Map
    MapX.Index = Index
    MapX.Name = "Map" & Index
    myMaps.Add Item:=MapX, Key:="M" & MapX.Index
    Set AddMapWithIndex = MapX
End Function

Public Function AddMap() As Map
    'Adds a Map and returns a reference to that Map
    Dim c As Integer
    Dim MapX As Map
    ' Find next available index for map adding
    c = 1
    For Each MapX In myMaps
        If MapX.Index >= c Then
            c = MapX.Index + 1
        End If
    Next MapX
    ' Set the index and add the map. Return the new map's index.
    Set MapX = New Map
    MapX.Index = c
    MapX.Name = "Map" & c
    myMaps.Add Item:=MapX, Key:="M" & MapX.Index
    Set AddMap = MapX
End Function

Public Sub RemoveMap(DeleteKey As String)
    myMaps.Remove DeleteKey
End Sub

Public Property Get TotalSize() As Long
    Dim MapX As Map
    For Each MapX In myMaps
        TotalSize = TotalSize + MapX.TotalSize
    Next MapX
End Property

Public Property Get TotalMaps() As Integer
    TotalMaps = myMaps.Count
End Property

Public Sub SaveToFile(ToFile As Integer)
    Dim c As Integer
    Put ToFile, , myVersion
    Put ToFile, , Len(myPassword)
    Put ToFile, , myPassword
    Put ToFile, , myMaps.Count
    For c = 1 To myMaps.Count
        myMaps(c).SaveToFile ToFile
    Next c
End Sub

Public Sub ReadFromFile(FromFile As Integer)
    Dim c As Integer, Cnt As Long, myMap As Map
    ' Read Password
    Get FromFile, , myVersion
    Get FromFile, , Cnt
    myPassword = ""
    For c = 1 To Cnt
        myPassword = myPassword & " "
    Next c
    Get FromFile, , myPassword
    ' Load Maps
    Get FromFile, , Cnt
    For c = 1 To Cnt
        Set myMap = New Map
        myMap.ReadFromFile FromFile
        myMaps.Add Item:=myMap, Key:="M" & myMap.Index
    Next c
End Sub

Public Property Get Maps() As Collection
    Set Maps = myMaps
End Property

