VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TerrainType"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private myIndex As Integer
'   Short description of the tile type (dark forest, woods, etc).
Private myName As String
'   If water, then bit 0 set, etc. (Yet to be defined)
Private myFlags As Byte
    '   4-7 - 16 Terrain Types:
    '       0   - Water
    '       1   - Forest
    '       2   - Dark Forest
    '       3   - Wasteland
    '       4   - Mountain
    '       5   - Desert
    '       6   - Grass
    '       7   - Town Area/Path
    '       8   - Wilderness Path
    '       9   - Swamp
    '       10  - Lava
    '       11  - Ice
    '       12  - Snowy
    '       13  - Hills
    '       14  - Rocky
    '       15  - River

Public Property Get Index() As Integer
    Index = myIndex
End Property

Public Property Let Index(NewIndex As Integer)
    myIndex = NewIndex
End Property

Public Property Get Name() As String
    Name = Trim(myName)
End Property

Public Property Let Name(NewName As String)
    myName = Trim(NewName)
End Property

Public Property Get Flags() As Byte
    Flags = myFlags
End Property

Public Property Let Flags(NewFlags As Byte)
    myFlags = NewFlags
End Property

Public Sub CopyTerrainType(ToTerrainType As TerrainType)
    ToTerrainType.Name = myName
    ToTerrainType.Flags = myFlags
End Sub

Public Sub PasteTerrainType(FromTerrainType As TerrainType)
    myName = FromTerrainType.Name
    myFlags = FromTerrainType.Flags
End Sub

Public Sub SaveToFile(ToFile As Integer)
    Put ToFile, , Len(myName)
    Put ToFile, , myName
    Put ToFile, , myIndex
    Put ToFile, , myFlags
End Sub

Public Sub ReadFromFile(FromFile As Integer)
    Dim c As Integer, Cnt As Long
    Get FromFile, , Cnt
    myName = ""
    For c = 1 To Cnt
        myName = myName & " "
    Next c
    Get FromFile, , myName
    Get FromFile, , myIndex
    Get FromFile, , myFlags
End Sub
