VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Trigger"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Version number of Class
Private myVersion As Integer
' Index for Trigger
Private myIndex As Integer
' Name for Trigger
Private myName As String
' Comments for this Trigger
Private myComments As String
' Trigger On (for Text of this, see Function)
Private myTriggerType As Byte
' Turns / Turns (how long it lasts) or Cost for a Skill.
Private myTurns As Byte
' Variables
Private myA As Byte, myB As Byte, myC As Byte

' Can have SkillPoints associated with it. The Party gets these points
' if they deactivate the Trigger. Or it can be used for other reasons
' inside the Trigger.Statements. This is Total spent for a Skill.
Private mySkillPoints As Integer
' Run-Time Only: Store temporary SkillPoints spent. Allows resetting of spend in game.
Private myTempSkill As Integer

' Trigger Style (Cast is special meaning this Trigger is a spell)
' Bit 0     - On=Skill
' Bit 1     - On=Trap
' Bit 2     - On=Curse
' Bit 3     - On=Poison
' Bit 4     - On=Evil
' Bit 5     - On=Fear
' Bit 6     - On=Magic
' Bit 7     - On=Timed
' Bit 8     - On=Lunacy
' Bit 9     - On=Revelry
' Bit 10    - On=Wrath
' Bit 11    - On=Pride
' Bit 12    - On=Greed
' Bit 13    - On=Lust
' Bit 14    - On=Fish
' Bit 15    - On=Not Used
Private myStyle As Integer
' Collection of Statements in Package
Private myStatements As New Collection
' Collection of Things (Creature, Item or Trigger) in Trigger
Private myCreatures As New Collection
Private myItems As New Collection
Private myTriggers As New Collection

Public Property Get Index() As Integer
    Index = myIndex
End Property

Public Property Let Index(NewIndex As Integer)
    myIndex = NewIndex
End Property

Public Property Get Name() As String
    Name = Trim(myName)
End Property

Public Property Let Name(NewName As String)
    myName = Trim(NewName)
End Property

Public Property Get Comments() As String
    Comments = Trim(myComments)
End Property

Public Property Let Comments(NewComments As String)
    myComments = Trim(NewComments)
End Property

Public Property Get TriggerType() As Byte
    TriggerType = myTriggerType
End Property

Public Property Let TriggerType(NewType As Byte)
    myTriggerType = NewType
End Property

Public Property Get SkillPoints() As Integer
    SkillPoints = mySkillPoints
End Property

Public Property Let SkillPoints(NewValue As Integer)
    mySkillPoints = NewValue
End Property

Public Property Get TempSkill() As Integer
    TempSkill = myTempSkill
End Property

Public Property Let TempSkill(NewValue As Integer)
    myTempSkill = NewValue
End Property

Public Property Get Statements() As Collection
    Set Statements = myStatements
End Property

Public Property Set Statements(NewValue As Collection)
    Set myStatements = NewValue
End Property

Public Property Get Turns() As Byte
    Turns = myTurns
End Property

Public Property Let Turns(NewValue As Byte)
    myTurns = NewValue
End Property

Public Property Get Creatures() As Collection
    Set Creatures = myCreatures
End Property

Public Property Get Items() As Collection
    Set Items = myItems
End Property

Public Property Get Triggers() As Collection
    Set Triggers = myTriggers
End Property

Public Function AddCreature() As Creature
    ' Adds an Creature and returns a reference to that Creature
    Dim c As Integer
    Dim CreatureX As Creature
    ' Find new available unused index idenifier
    c = 1
    For Each CreatureX In myCreatures
        If CreatureX.Index >= c Then
            c = CreatureX.Index + 1
        End If
    Next CreatureX
    ' Set the index and add the door. Return the new door's index.
    Set CreatureX = New Creature
    CreatureX.Index = c
    CreatureX.Name = "Creature" & c
    myCreatures.Add Item:=CreatureX, Key:="X" & CreatureX.Index
    Set AddCreature = CreatureX
End Function

Public Function AddCreatureAsIndex(Index As Integer) As Creature
    ' Adds an Creature and returns a reference to that Creature
    Dim c As Integer
    Dim CreatureX As Creature
    ' Set the index and add the door. Return the new door's index.
    Set CreatureX = New Creature
    CreatureX.Index = Index
    CreatureX.Name = "Creature" & Index
    myCreatures.Add Item:=CreatureX, Key:="X" & CreatureX.Index
    Set AddCreatureAsIndex = CreatureX
End Function

Public Sub RemoveCreature(DeleteKey As String)
    myCreatures.Remove DeleteKey
End Sub

Public Function AddItem() As Item
    ' Adds an Item and returns a reference to that Item
    Dim c As Integer
    Dim ItemX As Item
    ' Find new available unused index idenifier
    c = 1
    For Each ItemX In myItems
        If ItemX.Index >= c Then
            c = ItemX.Index + 1
        End If
    Next ItemX
    ' Set the index and add the door. Return the new door's index.
    Set ItemX = New Item
    ItemX.Index = c
    ItemX.Name = "Item" & c
    myItems.Add Item:=ItemX, Key:="I" & ItemX.Index
    Set AddItem = ItemX
End Function

Public Function AddItemAsIndex(Index As Integer) As Item
    ' Adds an Item and returns a reference to that Item
    Dim c As Integer
    Dim ItemX As Item
    ' Set the index and add the door. Return the new door's index.
    Set ItemX = New Item
    ItemX.Index = Index
    ItemX.Name = "Item" & Index
    myItems.Add Item:=ItemX, Key:="I" & ItemX.Index
    Set AddItemAsIndex = ItemX
End Function

Public Sub RemoveItem(DeleteKey As String)
    myItems.Remove DeleteKey
End Sub

Public Function AddTrigger() As Trigger
    ' Adds an Item and returns a reference to that Item
    Dim c As Integer
    Dim TriggerX As Trigger
    ' Find new available unused index idenifier
    c = 1
    For Each TriggerX In myTriggers
        If TriggerX.Index >= c Then
            c = TriggerX.Index + 1
        End If
    Next TriggerX
    ' Set the index and add the door. Return the new door's index.
    Set TriggerX = New Trigger
    TriggerX.Index = c
    TriggerX.Name = "Trigger" & c
    myTriggers.Add Item:=TriggerX, Key:="T" & TriggerX.Index
    Set AddTrigger = TriggerX
End Function

Public Function AddTriggerAsIndex(Index As Integer) As Trigger
    ' Adds an Item and returns a reference to that Item
    Dim c As Integer
    Dim TriggerX As Trigger
    ' Set the index and add the door. Return the new door's index.
    Set TriggerX = New Trigger
    TriggerX.Index = Index
    TriggerX.Name = "Trigger" & Index
    myTriggers.Add Item:=TriggerX, Key:="T" & TriggerX.Index
    Set AddTriggerAsIndex = TriggerX
End Function

Public Sub RemoveTrigger(DeleteKey As String)
    myTriggers.Remove DeleteKey
End Sub

Public Property Get Style(Index As Integer) As Integer
    Style = (myStyle And (2 ^ Index)) > 0
End Property

Public Property Let Style(Index As Integer, NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or (2 ^ Index)
    Else
        myStyle = myStyle And (Not 2 ^ Index)
    End If
End Property

Public Property Get Styles() As Integer
    Styles = myStyle
End Property

Public Property Let Styles(NewValue As Integer)
    myStyle = NewValue
End Property

Public Property Get IsSkill() As Integer
    IsSkill = (myStyle And &H1) > 0
End Property

Public Property Let IsSkill(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H1
    Else
        myStyle = myStyle And (Not &H1)
    End If
End Property

Public Property Get IsTrap() As Integer
    IsTrap = (myStyle And &H2) > 0
End Property

Public Property Let IsTrap(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H2
    Else
        myStyle = myStyle And (Not &H2)
    End If
End Property

Public Property Get IsPrimarySkill() As Integer
    IsPrimarySkill = (myStyle And &H2) > 0
End Property

Public Property Let IsPrimarySkill(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H2
    Else
        myStyle = myStyle And (Not &H2)
    End If
End Property

Public Property Get IsCurse() As Integer
    IsCurse = (myStyle And &H4) > 0
End Property

Public Property Let IsCurse(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H4
    Else
        myStyle = myStyle And (Not &H4)
    End If
End Property

Public Property Get IsPoison() As Integer
    IsPoison = (myStyle And &H8) > 0
End Property

Public Property Let IsPoison(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H8
    Else
        myStyle = myStyle And (Not &H8)
    End If
End Property

Public Property Get IsEvil() As Integer
    IsEvil = (myStyle And &H10) > 0
End Property

Public Property Let IsEvil(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H10
    Else
        myStyle = myStyle And (Not &H10)
    End If
End Property

Public Property Get IsFear() As Integer
    IsFear = (myStyle And &H20) > 0
End Property

Public Property Let IsFear(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H20
    Else
        myStyle = myStyle And (Not &H20)
    End If
End Property

Public Property Get IsMagic() As Integer
    IsMagic = (myStyle And &H40) > 0
End Property

Public Property Let IsMagic(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H40
    Else
        myStyle = myStyle And (Not &H40)
    End If
End Property

Public Property Get IsTimed() As Integer
    IsTimed = (myStyle And &H80) > 0
End Property

Public Property Let IsTimed(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H80
    Else
        myStyle = myStyle And (Not &H80)
    End If
End Property

Public Property Get IsLunacy() As Integer
    IsLunacy = (myStyle And &H100) > 0
End Property

Public Property Let IsLunacy(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H100
    Else
        myStyle = myStyle And (Not &H100)
    End If
End Property

Public Property Get IsRevelry() As Integer
    IsRevelry = (myStyle And &H200) > 0
End Property

Public Property Let IsRevelry(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H200
    Else
        myStyle = myStyle And (Not &H200)
    End If
End Property

Public Property Get IsWrath() As Integer
    IsWrath = (myStyle And &H400) > 0
End Property

Public Property Let IsWrath(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H400
    Else
        myStyle = myStyle And (Not &H400)
    End If
End Property

Public Property Get IsPride() As Integer
    IsPride = (myStyle And &H800) > 0
End Property

Public Property Let IsPride(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H800
    Else
        myStyle = myStyle And (Not &H800)
    End If
End Property

Public Property Get IsGreed() As Integer
    IsGreed = (myStyle And &H1000) > 0
End Property

Public Property Let IsGreed(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H1000
    Else
        myStyle = myStyle And (Not &H1000)
    End If
End Property

Public Property Get IsLust() As Integer
    IsLust = (myStyle And &H2000) > 0
End Property

Public Property Let IsLust(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H2000
    Else
        myStyle = myStyle And (Not &H2000)
    End If
End Property

Public Property Get IsFish() As Integer
    IsFish = (myStyle And &H4000) > 0
End Property

Public Property Let IsFish(NewValue As Integer)
    If NewValue Then
        myStyle = myStyle Or &H4000
    Else
        myStyle = myStyle And (Not &H4000)
    End If
End Property
                    
Public Property Get VarA() As Byte
    VarA = myA
End Property

Public Property Let VarA(NewA As Byte)
    myA = NewA
End Property

Public Property Get VarB() As Byte
    VarB = myB
End Property

Public Property Let VarB(NewB As Byte)
    myB = NewB
End Property

Public Property Get VarC() As Byte
    VarC = myC
End Property

Public Property Let VarC(NewC As Byte)
    myC = NewC
End Property

Public Function AddStatement(Optional AfterIndex As Variant) As Statement
    ' Adds an Statement and returns a reference to that Statement
    Dim c As Integer, i As Integer
    Dim StatementX As Statement
    ' Find new available unused index idenifier
    c = 1
    For Each StatementX In myStatements
        If StatementX.Index >= c Then
            c = StatementX.Index + 1
        End If
    Next StatementX
    ' Create the Statement and set the index
    Set StatementX = New Statement
    StatementX.Index = c
    ' Either add to end of Statements or Before a Statement
    If IsMissing(AfterIndex) Then
        myStatements.Add Item:=StatementX, Key:="S" & StatementX.Index
    Else
        myStatements.Add Item:=StatementX, Key:="S" & StatementX.Index, _
            After:="S" & AfterIndex
    End If
    Set AddStatement = StatementX
End Function

Public Function AddStatementAsIndex(Index As Integer) As Statement
    ' Adds an Statement and returns a reference to that Statement
    Dim c As Integer, i As Integer
    Dim StatementX As Statement
    ' Create the Statement and set the index
    Set StatementX = New Statement
    StatementX.Index = Index
    myStatements.Add Item:=StatementX, Key:="S" & StatementX.Index
    Set AddStatementAsIndex = StatementX
End Function

Public Sub Copy(FromTrigger As Trigger)
    Dim c As Integer
    Dim StatementX As Statement, CreatureX As Creature, ItemX As Item, TriggerX As Trigger
    Dim myStatement As Statement, myCreature As Creature
    Dim myItem As Item, myTrigger As Trigger
    ' Copy Name
    myName = FromTrigger.Name
    ' Copy Comments
    myComments = FromTrigger.Comments
    ' Copy Type, Turns and A, B and C
    myTriggerType = FromTrigger.TriggerType
    myTurns = FromTrigger.Turns
    myA = FromTrigger.VarA
    myB = FromTrigger.VarB
    myC = FromTrigger.VarC
    mySkillPoints = FromTrigger.SkillPoints
    myStyle = FromTrigger.Styles
    myTempSkill = FromTrigger.TempSkill
    ' Copy Statements to Trigger
    Set myStatements = New Collection
    For Each StatementX In FromTrigger.Statements
        Set myStatement = Me.AddStatementAsIndex(StatementX.Index)
        myStatement.Copy StatementX
    Next StatementX
    ' Copy Creatures to Trigger
    Set myCreatures = New Collection
    For Each CreatureX In FromTrigger.Creatures
        Set myCreature = Me.AddCreatureAsIndex(CreatureX.Index)
        myCreature.Copy CreatureX
    Next CreatureX
    ' Copy Items to Trigger
    Set myItems = New Collection
    For Each ItemX In FromTrigger.Items
        Set myItem = Me.AddItemAsIndex(ItemX.Index)
        myItem.Copy ItemX
    Next ItemX
    ' Copy Triggers to Trigger
    Set myTriggers = New Collection
    For Each TriggerX In FromTrigger.Triggers
        Set myTrigger = Me.AddTriggerAsIndex(TriggerX.Index)
        myTrigger.Copy TriggerX
    Next TriggerX
End Sub

Public Sub ReadFromFile(FromFile As Integer)
    Dim c As Integer, Cnt As Long
    Dim myStatement As Statement
    Dim myCreature As Creature, myItem As Item, myTrigger As Trigger
    ' Read Item Name, Index and Comments
    Get FromFile, , myVersion
    Get FromFile, , Cnt
    myName = ""
    For c = 1 To Cnt
        myName = myName & " "
    Next c
    Get FromFile, , myName
    ' Read Trigger Index
    Get FromFile, , myIndex
    ' Read Comments
    Get FromFile, , Cnt
    myComments = ""
    For c = 1 To Cnt
        myComments = myComments & " "
    Next c
    Get FromFile, , myComments
    ' Read Type, Turns and A, B and C
    Get FromFile, , myTriggerType
    Get FromFile, , myTurns
    Get FromFile, , myA
    Get FromFile, , myB
    Get FromFile, , myC
    Get FromFile, , mySkillPoints
    Get FromFile, , myStyle
    ' Read Statements for Trigger
    Set myStatements = New Collection
    Get FromFile, , Cnt
    For c = 1 To Cnt
        Set myStatement = New Statement
        myStatement.ReadFromFile FromFile
        myStatements.Add Item:=myStatement, Key:="S" & myStatement.Index
    Next c
    ' Read Creatures for Trigger
    Get FromFile, , Cnt
    For c = 1 To Cnt
        Set myCreature = New Creature
        myCreature.ReadFromFile FromFile
        myCreatures.Add Item:=myCreature, Key:="X" & myCreature.Index
    Next c
    ' Read Items for Trigger
    Get FromFile, , Cnt
    For c = 1 To Cnt
        Set myItem = New Item
        myItem.ReadFromFile FromFile
        myItems.Add Item:=myItem, Key:="I" & myItem.Index
    Next c
    ' Read Triggers for Trigger
    Get FromFile, , Cnt
    For c = 1 To Cnt
        Set myTrigger = New Trigger
        myTrigger.ReadFromFile FromFile
        myTriggers.Add Item:=myTrigger, Key:="T" & myTrigger.Index
    Next c
End Sub

Public Sub SaveToFile(ToFile As Integer)
    Dim c As Integer
    ' Save Trigger Index and Comments
    Put ToFile, , myVersion
    Put ToFile, , Len(myName)
    Put ToFile, , myName
    Put ToFile, , myIndex
    Put ToFile, , Len(myComments)
    Put ToFile, , myComments
    ' Save Type, Turns and A, B and C
    Put ToFile, , myTriggerType
    Put ToFile, , myTurns
    Put ToFile, , myA
    Put ToFile, , myB
    Put ToFile, , myC
    Put ToFile, , mySkillPoints
    Put ToFile, , myStyle
    ' Save Statements for Trigger
    Put ToFile, , myStatements.Count
    For c = 1 To myStatements.Count
        myStatements(c).SaveToFile ToFile
    Next c
    ' Save Creatures for Trigger
    Put ToFile, , myCreatures.Count
    For c = 1 To myCreatures.Count
        myCreatures(c).SaveToFile ToFile
    Next c
    ' Save Items for Trigger
    Put ToFile, , myItems.Count
    For c = 1 To myItems.Count
        myItems(c).SaveToFile ToFile
    Next c
    ' Save Triggers for Trigger
    Put ToFile, , myTriggers.Count
    For c = 1 To myTriggers.Count
        myTriggers(c).SaveToFile ToFile
    Next c
End Sub

Private Sub Class_Initialize()
    myTriggerType = 0   ' None
    myA = 0
    myB = 0
    myC = 0
End Sub
